<template>
  <single-panel>
    <ob-table
      :columns="groupsColumns"
      :functionalPanel="true"
      :remote-opt="{
        method: getGroups
      }"
      :show-add-button="true"
      add-button-text="Создать группу"
      :tableLayoutFixed="false"
      :isSmartPagination="false"
      data-qa="LogisticDomainsGroupsTable"
      @select="onSelect"      
      @add="onAdd"
      ref="obTableAllGroups"
      is-fixed-header
      :is-functional-sort="false"
      :is-functional-group="false"
    >
      <template v-slot:changeDate="{ data }">
        <div class="date">
          {{data.item.changeDate}},
          <span>{{data.item.changeTime}}</span>
        </div>
      </template>
      <template v-slot:createDate="{ data }">
        <div class="date">
          {{data.item.createDate}},
          <span>{{data.item.createTime}}</span>
        </div>
      </template>
      <template v-slot:actions="{ data }">
        <ob-menu-dropdown
          :items="[{ title: 'Изменить название или описание', method: () => onAdd(data) }, {title: 'Удалить группу', method: () => confirmDelete(data)}]"
          trigger="click"
        >
        </ob-menu-dropdown>
      </template>
      <template slot="noneContent">
        <div class="no-content">
          <p>Здесь еще нет ни одной записи.</p>
          <p>Создавайте группы и добавляйте в них контрагентов</p>
          <span @click="onAdd">Создать группу</span>
        </div>
      </template>
    </ob-table>

    <ob-modal
      ref="groupModal"
      :title="selectedGroup.uuid ? 'Изменение названия и описания' : 'Группа'"
      :is-show-controls="false"
      size="medium"
      @closed="onGroupModalClose"
    >
      <GroupModal
        @submitted="onSubmittedForm"
        :data-source="selectedGroup"
      />
    </ob-modal>

    <ob-modal
      ref="deleteGroupModal"
      :title="`Удаление группы «${selectedGroup.title}»`"
      size="medium"
      :is-show-controls="true"
      isError
      ok-text="Удалить группу"
      @submit="onDeleteGroupAgents"
    >
      Вы точно хотите удалить группу и расформировать список из {{ plural(selectedGroup.participantCount, 'контрагента | контрагентов | контрагента') }}? 
    </ob-modal>
  </single-panel>
</template>

<script>
  import {uuid} from "vue-uuid";
  import api from '@/api';
  import SinglePanel from "common-components/src/obComponents/obSinglePanels";
  import ObTable from "common-components/src/obComponents/obTable";
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
  import ObModal from "common-components/src/obComponents/obModal";
  import GroupModal from "./components/groupModal";

  export default {
    name: 'logisic_domains_groups',

    components: {
      SinglePanel,
      ObTable,
      ObMenuDropdown,
      ObModal,
      GroupModal,
    },

    data() {
      return {
        selectedGroup: {isTitleValid: true},
        selectedAgents: [],
      }
    },

    computed: {
      groupsColumns() {
        return [
          {
            title: '',
            slotName: 'checkbox',
            isToggleDisabled: true
          },
          {
            title: 'Название группы',
            key: 'title'
          },
          {
            title: 'количество контрагентов',
            key: 'participantCount'
          },
          {
            title: 'последнее изменение',
            key: 'lastChangedAt',
            slotName: 'changeDate'
          },
          {
            title: 'группа создана',
            key: 'createdAt',
            slotName: 'createDate'
          },
          {
            title: 'кто создал',
            key: 'creator'
          },
          {
            title: '',
            slotName: 'actions',
            action: true,
            isToggleDisabled: true
          }
        ]
      }
    },

    methods: {
      async  getGroups({page, size, sort = "createdAt, desc", query}) {
        const altSort = sort?.split(',')
        try {
          let res = await api.linkBrowser.getAllGroups({page, size, sort: altSort[0], direction: altSort[1], query});
          const timeOptions = {
            hour: 'numeric',
            minute: '2-digit'
          };

          res.content = res.content.map(item => {
            const createDate = item.createdAt ? (new Date(item.createdAt)).toLocaleDateString('ru-RU') : '—';
            const createTime = item.createdAt ?(new Date(item.createdAt)).toLocaleTimeString('ru-RU', timeOptions) : '—';
            const changeDate = item.lastChangedAt ? (new Date(item.lastChangedAt)).toLocaleDateString('ru-RU') : '—';
            const changeTime = item.lastChangedAt ? (new Date(item.lastChangedAt)).toLocaleTimeString('ru-RU', timeOptions) : '—';
            return {
              "uuid": item.uuid,
              "title": item.title,
              "description": item.description,
              "participantCount": item.participantCount,
              changeDate,
              changeTime,
              createDate,
              createTime,
              "creatorUuid": item.creatorUuid,
              "firstname": item.firstname,
              "lastname": item.lastname,
              creator: `${item.lastname} ${item.firstname}`,
              isTitleValid: true
            }
          });
          return res;
        } catch (err) {
          console.error(err);
        }
      },

      onSelect(data) {
        console.log('selected ->', data);
        this.$router.push(`/browser_link__groups/group/${data.uuid}?name=${data.title}`);
      },

      onAdd(data) {
        if (data.item) {
          this.selectedGroup = data.item;
        }
        this.$refs.groupModal.open()
      },

      onChangeGroup(group) {
        console.log('onChangegroup ->', group);
      },

      onDeleteGroup(group) {
        this.selectedGroup = group.item;
        this.confirmDelete();
      },

      confirmDelete(group) {
        this.selectedGroup = group.item;
        this.$refs.deleteGroupModal.open();
      },

      async onDeleteGroupAgents() {
        await api.linkBrowser.deleteGroup(this.selectedGroup.uuid)
        this.$refs.deleteGroupModal.close();
        this.$refs.obTableAllGroups.loadData({ init: true }) 
      },

      onGroupModalClose() {
        this.selectedGroup = {isTitleValid: true};
      },

      async onSubmittedForm(data) {
        const groupUuid = this.selectedGroup.uuid ? this.selectedGroup.uuid :  uuid.v4();
        const {title, description} = data;
        const payload = {
          uuid: groupUuid,
          title,
          description
        }
        try {

          await api.linkBrowser.addGroup(groupUuid, payload);
          
          this.$refs.groupModal.close()
          this.$refs.obTableAllGroups.loadData({ init: true }) 

        } catch (error) {
          this.selectedGroup.isTitleValid = false;

        }
      },

      plural(value, unit) {
        return `${value} ${this.declOfNum(value, unit)}`;
      },

      declOfNum(n, string) {
        let titles = string.split("|");
        return titles[
          n % 10 == 1 && n % 100 != 11
            ? 0
            : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20)
            ? 1
            : 2
        ];
      },
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

  .left {
    margin: 20px;
    position: relative;
  }

  .no-content {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;

    p {
      @include font-mixin(24px, 40px, 400, $color-grey-span);
    }

    span {
      margin-top: 20px;
      @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
      text-decoration: none;
      cursor: pointer;
    }
  }

  ::v-deep {
    td:last-child {
      width: 58px;

      .td-container {
        padding: 0;
        display: none;
      }
    }

    tr:hover > td:last-child .td-container {
      display: flex;
    }
  }
</style>